#include "decl_fwd.h"

#include <complex>
#include <fftw3.h>

namespace Yang {
  class fft3d {
  public:
    void readParam(const param_func* pars, const hypercube& inShape);
    void before_trans();
    void transform(cubeData<cmplxf>& cbin, cubeData<cmplxf>& cbout);
    const hypercube& inShape() const {return this->inShape_;}
    const hypercube& outShape()const {return this->outShape_;}
    ~fft3d();
  private:
    int sign_[3],ndim_,n_[3],no_[3];
    hypercube inShape_,outShape_;
    cubeData<cmplxf> inCube_;
    std::vector< cubeData<cmplxf>* > pOutCubeVecs_;
    std::vector<fftwf_complex*> fftwin2d_, fftwin_;
    std::vector<fftwf_plan> FFTplan_[3];
    float scalar_;
  };
} //end namespace

