#ifndef __MPI_UTIL_H_INCL__
#define __MPI_UTIL_H_INCL__

#include "decl_fwd.h"

namespace Yang {

string get_basename_from_path(const string& fullpath);

class branchFileName {
public:
  branchFileName(const std::string &origFileName, const string &suf = string(""));
  std::string   fn_at(int irank) const;
  const std::string&  fn_orig()          const { return origFn_;}
  std::string   stackCmd(int nrank) const;
  std::string   catCmd(int nrank, int iAxis) const;
private:
  std::string origFn_,suf_;
  std::stringstream ss_;
  size_t extPos_;
};

//Schedule the work evently on "np" processes, 0 based.
class workScheduler1d {
public:
  enum scheduleType {hopping, chunk};
  workScheduler1d(int njobs, int np, scheduleType sType = chunk);
  void get_nod(int irank, int *n, int *o, int *d) const {
    VERIFY(irank < ns_.size()); VERIFY(irank >= 0);
    *n = ns_[irank];  *o = os_[irank]; *d = ds_[irank];
  }
  int njobs() const { return njobs_;}
  int np()    const { return np_;}

private:
  std::vector<int> ns_,os_,ds_;
  int njobs_,np_;
  scheduleType sType_;
};

int split_file_MPI(const string &fnIn, const string &sufOut, int iAxis, const workScheduler1d &ws, string datapath = "");
int dup_file_MPI(const string &fnIn, const string &sufOut, const workScheduler1d &ws, string datapath);

} //end namespace Yang

#endif // __MPI_UTIL_H_INCL__

