#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "cubeAlgo2.h"
#include "stackTraceC.h"
using namespace Yang;
using namespace std;

//Rearrange Hessian between matrix form and 6-D filter form
int main( int argc, char** argv) {
   initCallStackTrace();
   //Read params
   auto_ptr<sep_params> autoPars(new sep_params(argc,argv));
   
   //in is the model
   //out is the gradiant
   
   //Hessian is 6 dimension, (x,y,z,xoff,yoff,zoff)
   cubeDataF input("in",dm::IN,"model",6);
   input.init(NULL);
   
   bool bFromFilterToMatrix = autoPars->get_bool("toMatrix");
   
   //!!! Not finished
   
   int ix,iy,iz;
   int iox,ioy,ioz;
   
   cubeDataF outCube;
   const hypercube& shp = input.domain();
   const vecAxis& axes = shp.get_axes();
   shp.info("Input shape");
   
   float esum = 0.0f; int noxyz = axes[3].n*axes[4].n*axes[5].n;
   outCube.alloc(shp); 
   for (ix=0; ix<axes[0].n; ix++) {
     for (iy=0; iy<axes[1].n; iy++) {
       for (iz=0; iz<axes[2].n; iz++) {
         esum = 0.0f;
         for (iox=0; iox<axes[3].n; iox++) {
           for (ioy=0; ioy<axes[4].n; ioy++) {
             for (ioz=0; ioz<axes[5].n; ioz++) {
               esum += SQ(input(ioz,ioy,iox,iz,iy,ix));
             }
           }
         }
         //Now use this as divisor
         esum /= noxyz; esum = sqrtf(esum);
         for (iox=0; iox<axes[3].n; iox++) {
           for (ioy=0; ioy<axes[4].n; ioy++) {
             for (ioz=0; ioz<axes[5].n; ioz++) {
               outCube(ioz,ioy,iox,iz,iy,ix) = input(ioz,ioy,iox,iz,iy,ix)/esum;
             }
           }
         }
       }
     }
   }
   outCube.dump("out");
}

