#include "stdafx.h"
#include "dmRsf.hpp"
#include "cubeData.hpp"
#include "sep_params.h"
#include "misc.h"
#include "cubeAlgo.h"
#include "cubeAlgo2.h"

/**
 * like seplib Add, but can internally dupliate one operand, like f3(z,x,hx) = f1(z,x,hx)*f2(z,x).
 */

//Reflection case
using namespace Yang;
using namespace std;

using boost::shared_ptr;
//Doing beam wave-equation tomography for reflection case.

//Do born modeling
int main (int argc, char *argv[])
{
  shared_ptr<sep_params> pars(new sep_params(argc,argv));
  //get the filename, 
  //The outfile will be in the same folder as in File
  string fnIn   = pars->get_string("inFile");
  string datapath = pars->get_string("datapath","");
  int iAxis = pars->get_int("axis"); //divide through with axis
  int np    = pars->get_int("np");
  VERIFY(np>1);
  np -= 1; //number of slaves.
  
  //Read in the header info.
  sepHeaderReader hReader(fnIn, dm::IN, "", true);
  hypercube shp;
  hReader.getShape(shp);
  
  VERIFY(0);//Not implemented yet!!
  shp.info("shp");
  return 0;
}

