#include "stdafx.h"
#include "decl_fwd.h"

#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"

#include "cubeData.hpp"
#include "sep_params.h"
#include "stackTraceC.h"

/*
 * Generate Vnmo based on Vp and delta using the formula
 Vnmo = Vp*sqrt(1+2*delta)
 */

using boost::shared_ptr;
using namespace Yang;
using namespace std;

int main (int argc, char *argv[]) {
  initCallStackTrace();
  //Read params
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> vmod(new cubeDataF()), delta(new cubeDataF());
  
  vmod->load("in",NUM_AXIS_DEFAULT); //load in the radon domain size.
  delta->load("delta",NUM_AXIS_DEFAULT);
  
  //Then input the delta mask
  VERIFY(delta->domain().sameSize(vmod->domain()));
  delta->scale(2.0f);
  delta->add(1.0f);
  
  delta->sqrt();
  vmod->multiply(*delta);
  vmod->dump("out");
}

