#include "stdafx.h"
#include "sep_params.h"
#include "cubeData.hpp"
#include "dmHeaderReader.h"

using namespace Yang;
using namespace Yang;

///Strip out the dummy Axis from the input data file
///The dummy Axis are those defined in the middle of the axes. (including the first and last ones)
///with n=1 d=1 o=0
/// Usage:  *.x ouput=output.H <in.H
int main(int argc, char* argv[]) {
	//have to init par
	sep_params* pars = new sep_params(argc,argv);
  sepHeaderReader inputInfo("in",dm::IN,"input");
  sepHeaderWriter headerOut("output");

	hypercube inShape,outShape;
	bool bRemoveEndDummyAxis = true;
	inputInfo.getShape(inShape,bRemoveEndDummyAxis);
	vecAxis inAxes = inShape.get_axes();
	
	bool bIsDummy;
	vecAxis outAxes;
	
	for (unsigned int i=0; i<inAxes.size(); i++) {
		const axis& ax = inAxes[i];
		//bIsDummy = (ax.n==1 && equalf(ax.d,1.0f) && equalf(ax.o,0.0f));
		bIsDummy = (ax.n==1);
		if (!bIsDummy) {
			outAxes.push_back(ax);
		}
	}

	outShape.set_axes(outAxes);
	inShape.info("inShape"); outShape.info("outShape");
  
  LOG(A2);  
  int esize = inputInfo.getElemSize();
  headerOut.writeDomain(outShape,esize);
  LOG(A3);
  string fn_output = pars->get_string("output");
  
  //don't need to copy, just write to the header files
  string str_bin = inputInfo.get_auxpar_string("in","in");
  char sz_cmd[2048];
  sprintf(sz_cmd,"echo next in=\"%s\" >>%s ", str_bin.c_str(),fn_output.c_str());
  PRV(sz_cmd);
  VERIFY(0==system(sz_cmd));
  SEEV(str_bin);
  return 0;
}

