
#include "stdafx.h"
#include "decl_fwd.h"

#include "axis.h"
#include "dmRsf.hpp"
#include "dmRsfDump.h"

#include "cubeData.hpp"
#include "cubeAlgo2.h"
#include "misc.h"

#include "sep_params.h"
#include "stackTraceC.h"

/*
 * Generate ormsby wavelet, based on the four frequencies.
 */


using boost::shared_ptr;
using namespace Yang;
using namespace std;

int main (int argc, char *argv[]) {
  initCallStackTrace();
  //Read params
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  shared_ptr<cubeDataF> wavelet(new cubeDataF());

  int nRead;axis ax_t;
  shared_ptr<float> freqs(pars->get_floats("freqs",4,NULL,&nRead));
  read_axis_from_par(ax_t, pars, "1", NULL,NULL,NULL);
  
  ax_t.print_info("t axis ");
  wavelet->alloc(hypercube(vecAxis(1,ax_t)));
  getOrmsbyFunc(*wavelet,ax_t,freqs.get());
  wavelet->dump("out");
}

