#ifndef WAVE_OP_MPI_H
#define WAVE_OP_MPI_H

#include "stdafx.h"
#include "axis.h"


void inline hinaxis(char *filename, axis *ax, int ndim){
  char sz[512];
  if (0!=sep_get_data_axis_par(filename,&ndim,&(ax->n),&(ax->o),&(ax->d),sz))
                 seperr("trouble reading axis %d to tag %s\n",ndim,filename);
  ax->label = sz;
}

void inline houaxis(char *filename, axis *ax, int ndim){
  char sz[512]; strcpy(sz,ax->label.c_str());  
  if (0!=sep_put_data_axis_par(filename,&ndim,&(ax->n),&(ax->o),&(ax->d),sz))
                 seperr("trouble writing axis %d to tag %s\n",ndim,filename);
}

inline void fio_imag_1way(float *imag, int nhx, int nhy, int nx, int ny, int nz, int iz, char *filetag, int flag) {
  int n_cube[5], j_wind[5], n_wind[5], f_wind[5];
  int n_dim_cube;
  
  n_dim_cube = 5;
  n_cube[0] = nhx; n_cube[1] = nhy; n_cube[2] = nx; n_cube[3] = ny; n_cube[4] = nz  ;
  j_wind[0] = 1  ; j_wind[1] = 1  ; j_wind[2] = 1 ; j_wind[3] = 1 ; j_wind[4] = 1   ;
  n_wind[0] = nhx; n_wind[1] = nhy; n_wind[2] = nx; n_wind[3] = ny; n_wind[4] = 1   ;
  f_wind[0] = 0  ; f_wind[1] = 0  ; f_wind[2] = 0 ; f_wind[3] = 0 ; f_wind[4] = iz-1;
  
  if (flag==0) {
     sreed_window(filetag,&n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,imag);
  } 
  else if (flag==1) {
     srite_window(filetag,&n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,imag);
  }
}

//For one-way operator string manipulation

//copy each file from one directory to each local directories
inline void create_cpy_one2all(string& cpy_file, const char *tmpdir, const char *fnone, const char *fnall) {
  cpy_file="Cp "; cpy_file += fnone; cpy_file += " "; cpy_file += fnall;
  cpy_file += " datapath="; cpy_file += tmpdir;
}

//copy each file from local directorires to one shared direcotry
inline void create_cpy_all2one(string& cpy_file, const char *fnone, const char *fnall){
  cpy_file="Cp "; cpy_file += fnall; cpy_file += " "; cpy_file += fnone;
}

inline void create_cmd_imagcube(char *cmd_imagcube, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fnbimg, char *par_imagcube){
  strcpy(cmd_imagcube, bindir      ); strcat(cmd_imagcube, "imagcube-mpi.x"); strcat(cmd_imagcube, " csou="); strcat(cmd_imagcube, fncsou      );
  strcat(cmd_imagcube, " crec="    ); strcat(cmd_imagcube, fncrec          ); strcat(cmd_imagcube, " bvel="); strcat(cmd_imagcube, fnbvel      );
  strcat(cmd_imagcube, " bimg="    ); strcat(cmd_imagcube, fnbimg          ); strcat(cmd_imagcube, " "     ); strcat(cmd_imagcube, par_imagcube);
  strcat(cmd_imagcube, " datapath="); strcat(cmd_imagcube, tmpdir          );
}

inline void create_cmd_residual(char *cmd_residual, char *bindir, char *tmpdir, char *fnbimg, char *fnfobj, char *fnimsk, char *par_residual){
  strcpy(cmd_residual, bindir      ); strcat(cmd_residual, "residual-mpi.x"); strcat(cmd_residual, " bimg="    ); strcat(cmd_residual, fnbimg);
  strcat(cmd_residual, " fobj="    ); strcat(cmd_residual, fnfobj          ); strcat(cmd_residual, " imsk="    ); strcat(cmd_residual, fnimsk);
  strcat(cmd_residual, " "         ); strcat(cmd_residual, par_residual    ); strcat(cmd_residual, " datapath="); strcat(cmd_residual, tmpdir);
}

inline void create_cmd_gradient(char *cmd_gradient, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fndimg, char *fndvel, char *par_gradient) {
  strcpy(cmd_gradient, bindir  ); strcat(cmd_gradient, "gradient-mpi.x"); strcat(cmd_gradient, " csou="    ); strcat(cmd_gradient, fncsou);
  strcat(cmd_gradient, " crec="); strcat(cmd_gradient, fncrec          ); strcat(cmd_gradient, " bvel="    ); strcat(cmd_gradient, fnbvel);
  strcat(cmd_gradient, " dimg="); strcat(cmd_gradient, fndimg          ); strcat(cmd_gradient, " dvel="    ); strcat(cmd_gradient, fndvel);
  strcat(cmd_gradient, " "     ); strcat(cmd_gradient, par_gradient    ); strcat(cmd_gradient, " datapath="); strcat(cmd_gradient, tmpdir);
}

inline void create_cmd_gradprcs(char *cmd_gradprcs, char *bindir, char *tmpdir, char *fngrdo, char *fngmsk, char *fnbimg, char *par_gradprcs){
  strcpy(cmd_gradprcs, bindir      ); strcat(cmd_gradprcs, "gradprcs-mpi.x"); strcat(cmd_gradprcs, " grdo="); strcat(cmd_gradprcs, fngrdo);
  strcat(cmd_gradprcs, " gmsk="    ); strcat(cmd_gradprcs, fngmsk          ); strcat(cmd_gradprcs, " bimg="); strcat(cmd_gradprcs, fnbimg);
  strcat(cmd_gradprcs, " "         ); strcat(cmd_gradprcs, par_gradprcs    );
  strcat(cmd_gradprcs, " datapath="); strcat(cmd_gradprcs, tmpdir          );
}

inline void create_cmd_srchdrct(char *cmd_srchdrct, char *bindir, char *tmpdir, char *fnsrch, char *fngrdo, char *fngrdp, char *method){
  strcpy(cmd_srchdrct, bindir  ); strcat(cmd_srchdrct, "srchdrct-mpi.x"); strcat(cmd_srchdrct, " srch="); strcat(cmd_srchdrct, fnsrch);
  strcat(cmd_srchdrct, " grdo="); strcat(cmd_srchdrct, fngrdo          ); strcat(cmd_srchdrct, " grdp="); strcat(cmd_srchdrct, fngrdp);
  strcat(cmd_srchdrct, method  ); strcat(cmd_srchdrct, " datapath="    ); strcat(cmd_srchdrct, tmpdir  );
}

inline void create_cmd_initfile(char *cmd_initfile, char *bindir, char *tmpdir, char *fnmmov, char *fnfmov, char *par_initfile){
  strcpy(cmd_initfile, bindir      ); strcat(cmd_initfile, "initfile-mpi.x"); strcat(cmd_initfile, " mmov="); strcat(cmd_initfile, fnmmov      );
  strcat(cmd_initfile, " fmov="    ); strcat(cmd_initfile, fnfmov          ); strcat(cmd_initfile, " "     ); strcat(cmd_initfile, par_initfile);
  strcat(cmd_initfile, " datapath="); strcat(cmd_initfile, tmpdir          );
}

inline void create_cmd_bornmodl(char *cmd_bornmodl, char *bindir, char *tmpdir, char *fncsou, char *fncrec, char *fnbvel, char *fnbimg, char *par_bornmodl){
  strcpy(cmd_bornmodl, bindir      ); strcat(cmd_bornmodl, "bwi-wem3d.x"); strcat(cmd_bornmodl, " csou="); strcat(cmd_bornmodl, fncsou      );
  strcat(cmd_bornmodl, " crec="    ); strcat(cmd_bornmodl, fncrec       ); strcat(cmd_bornmodl, " bvel="); strcat(cmd_bornmodl, fnbvel      );
  strcat(cmd_bornmodl, " bimg="    ); strcat(cmd_bornmodl, fnbimg       ); strcat(cmd_bornmodl, " "     ); strcat(cmd_bornmodl, par_bornmodl);
  strcat(cmd_bornmodl, " datapath="); strcat(cmd_bornmodl, tmpdir       );
}

namespace Yang {
  //an auxiliary class for collecting all the small data piece files info in 3-D seimsic applications. It would read in a text-based description files, and from there figure out the dimension informations of all small pieces.
class shotFilesInfo {
public:
  shotFilesInfo();
  const hypercube& vmodShape() const {return *vmodShape_2way_;}
  int parsefile(const string& fname, const boost::shared_ptr<hypercube>& vmodShape_2way, int ishot_beg=0, int ishot_end=-1);
  //the data is always 3D
  //const PosInt& nShots() {return m_nShots;}
  const int& m_nSuperShots() const {return m_nSuperShots_;}
  
  void getDataAndSrcFile(string& fn_data, string& fn_src, int iShot) const;
  //Get migration image/aperture size and locations based on the src/recv coverages.
  void getImagingDomainFlags (bool& xmin, bool& xmax, bool& ymin, bool& ymax, bool& zmin, bool& zmax) const; //call this before getImagingDomain, so you know which of dimension parameters are called.
  void getImagingDomain (float& xmin, float& xmax, float& ymin, float& ymax, float& zmin, float& zmax, int iShot) const;
  void getGlobalImgDomain(float& xmin, float& xmax, float& ymin, float& ymax, float& zmin, float& zmax) const;

  bool bMarineGeometry() const{return bMarineGeom_;}
private:
  boost::shared_ptr<const hypercube> vmodShape_2way_;
  int   m_nShots;
  int   m_nSuperShots_; //number of shots and number of supershots, here, supershots means the number of file pieces.
  std::string fname_desc_; //the name of description files.
  boost::shared_ptr<std::ifstream> fstrm_desc_; //the file pointer to the desc files
  std::vector<string> fnames_shots_,fnames_src_;
  bool bSameSrcForAllShots_; //if single pt src or areal shots
  std::vector<float> xminv_,xmaxv_,yminv_,ymaxv_,zminv_,zmaxv_;
  bool bColFlags_[6]; //corresponding to xmin,xmax,ymin,ymax,zmin,zmax
  bool bMarineGeom_;
  int ishot_beg_,ishot_end_;
};

} //end namespace Yang


#ifndef USE_MPI

#else

//the MPI part
#include <mpi.h>
#include "decl_fwd.h"
#include "my_mpi.h"
#include "waveOpOneway.h"
//#include <boost/mpi.hpp>

namespace Yang {

class waveOpOnewayMPI: public waveOpOneway  //Using MPI, the simplest data-parallelization.
{
  public://methods
    waveOpOnewayMPI(const shared_ptr<waveOpParams>& waveOpPar, const shared_ptr<AcqPar>& acqPars,
            const shared_ptr<ImgPar>& imgPars,   const vel& vmod, param_func* pars, const shared_ptr<workScheduler1d>& ws);

//  virtual void modeling_op(    cubeData<float>* pVelCube, dmRsf<float>* pRsfSeisRec);
//  virtual void bornModeling_op(cubeData<float>* pReflCube, dmRsf<float>* pRsfSeisRec); //Need to set acquisition and etc.
//
//  //in core & out of core
//  virtual void migration_op(dmRsf<float>* pRsfSeisRec,  cubeData<float>* pImageCube);
//  virtual void migration_op(const string& dataFile,     cubeData<float>* pImageCube);
//  virtual void migration3d_op(const string& fn_seisRec, const string& fn_img_off); //3d
//
//  virtual void TomAdj_op   (cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);
//  virtual void TomAdj3d_op (const string& fn_dImg_off, cubeData<float>& dslwCube);  //3d case
    
    virtual void TomAdj_op   (cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);
    virtual void TomoImit_op (const cubeData<float>* pRefl, const cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);

  private:
    virtual void migration(OneWayParamTang& param, cubeDataF* pImageCube); //invoke Yaxun's program and handle the data format conversion.
    virtual void bornModeling(OneWayParamTang& param, const cubeDataF* pRefl);
    
    void setGeomPar(char* szGeom, const OneWayParamTang* par, int nrank=1,  int irank=1); //for both MPI and non MPI case.
private:
  mpiY::communicator world_;
  string strTmpDir_;
  boost::shared_ptr<workScheduler1d> ws_;
  //std::string oper;
};

class waveOpOnewayMPI3d: public waveOpOneway  //Using MPI, the simplest data-parallelization.
{
  public://methods
    waveOpOnewayMPI3d(const shared_ptr<waveOpParams>& waveOpPar, const shared_ptr<AcqPar>& acqPars,
            const shared_ptr<ImgPar>& imgPars,   const vel& vmod, param_func* pars, const boost::shared_ptr<shotFilesInfo>& shotFilesInfo_in);
    virtual void TomAdj_op   (cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);
    virtual void TomoImit_op (const cubeData<float>* pRefl, const cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);

protected:
  virtual void setOneWayParam(OneWayParamTang* par);
  void  deployVelModel(OneWayParamTang& param, const branchFileName& bf_vel_local);

private:
  virtual void migration(OneWayParamTang& param, cubeDataF* pImageCube); //invoke Yaxun's program and handle the data format conversion.
  virtual void bornModeling(OneWayParamTang& param, const cubeDataF* pRefl);
  
  void setGeomPar(char* szGeom, const OneWayParamTang* par, int nrank=1,  int irank=1); //for both MPI and non MPI case.
  void gen_mig3d_cmd(string& str_cmd, hypercube& outImgShp, const OneWayParamTang& param,int iJob, int iwrk, const Yang::shotFilesInfo& sfInfo, const hypercube& global_imgShp, const branchFileName& bf_imag, const branchFileName& bf_log, const branchFileName& bf_vel_local);
private:
  mpiY::communicator world_;
  string strTmpDir_;
  boost::shared_ptr<shotFilesInfo> shotFilesInfo_;
};
} //end namespace

#endif
#endif

