#!/bin/tcsh
### first is the common part
###   each node is dual CPU with Quad core Nehalem
#PBS -N nmoB_1sh
#PBS -l nodes=1:ppn=8
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -j oe
#PBS -e /data/sep/zyang03/proj/RMO/waz3d/wrk
#PBS -o /data/sep/zyang03/proj/RMO/waz3d/wrk
#PBS -d /data/sep/zyang03/proj/RMO/waz3d/wrk
#

#
cd $PBS_O_WORKDIR
#

echo WORKDIR is: $PBS_O_WORKDIR
echo NodeFile is: $PBS_NODEFILE
echo hostname is: $HOSTNAME

set BINDIR=/data/sep/zyang03/bin
set DATDIR=/data/sep/zyang03/data/waz
set RESDIR=/data/sep/zyang03/proj/RMO/waz3d

set TMPDIR=/tmp
set HOSTFILE=hostfile_${PBS_JOBID}
echo hostfile is: ${HOSTFILE}
cat ${PBS_NODEFILE} | sort | uniq > ${HOSTFILE}
#strip out the first line and appended to the first line of hostfile
set ROOTNODE=`head ${HOSTFILE} -n 1`
echo ${ROOTNODE} >> ${HOSTFILE}
#sed -i "1s/^/${ROOTNODE}\n/" ${HOSTFILE}

set NWRKS=`wc -l ${HOSTFILE} | gawk '//{print $1}'`
set NPROCS=${NWRKS}
#@ NWRKS ++
echo np is: ${NPROCS},${NWRKS}
echo env dh is: ${DH}

set MPI_PAR="wemig-1way=${DH}/other/yaxun_weo/bin/bwi-wem3d-Zh.x wewet-1way=${DH}/other/yaxun_weo/bin/bwi-wet3d.x"
echo ${MPI_PAR}

set MIG_PAR_WAZ3D=" pdip=65 oper=ssfpi nvrf=4 nws=32 nxpad_beg=40 nxpad_end=40 nypad_beg=30 nypad_end=30 ntpx=25 ntpy=25 memchk=n "
echo "MIG_PAR_WAZ3D=" $MIG_PAR_WAZ3D

set dump="dump1=dump1.H dump2=dump2.H"
set P="/data/sep/zyang03/proj/RMO/Par"
set B="/data/sep/zyang03/bin"

#${cmd} add_migpar_1w=" ${MIG_PAR_WAZ3D} " >&log imgh=imgh-waz3dsm.H
#set PAR_HESS=" nhx=1 dhx=25 ohx=0 comsou=n grecin=y hestyp=2 rdmtype=2 offset=y "
set PAR_HESS=" nhx=21 dhx=50 ohx=-500 nhy=19 dhy=60 ohy=-540 comsou=n grecin=y hestyp=2 rdmtype=2 offset=y "
#image_zmin=10 image_zmax= "

