#!/bin/tcsh
###   first is the common part   
###   CHANGE the waz3d_report path to your designated folder
###   each node is dual CPU with Quad core Nehalem
#PBS -N mig_A_1sh
#PBS -l nodes=1:ppn=8
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -j oe
#PBS -e /data/sep/zyang03/proj/RMO/waz3d_report/wrk
#PBS -o /data/sep/zyang03/proj/RMO/waz3d_report/wrk
#PBS -d /data/sep/zyang03/proj/RMO/waz3d_report/wrk
#

#
cd $PBS_O_WORKDIR
#

echo WORKDIR is: $PBS_O_WORKDIR
echo NodeFile is: $PBS_NODEFILE
echo hostname is: $HOSTNAME

set BINDIR=/data/sep/zyang03/bin
set DATDIR=/data/sep/zyang03/proj/RMO/waz3d_report/data
set RESDIR=/data/sep/zyang03/proj/RMO/waz3d_report

set TMPDIR=/tmp
set HOSTFILE=hostfile_${PBS_JOBID}
echo hostfile is: ${HOSTFILE}
cat ${PBS_NODEFILE} | sort | uniq > ${HOSTFILE}
#strip out the first line and appended to the first line of hostfile
set ROOTNODE=`head ${HOSTFILE} -n 1`
echo ${ROOTNODE} >> ${HOSTFILE}
#sed -i "1s/^/${ROOTNODE}\n/" ${HOSTFILE}

set NWRKS=`wc -l ${HOSTFILE} | gawk '//{print $1}'`
set NPROCS=${NWRKS}
#@ NWRKS ++
echo np is: ${NPROCS},${NWRKS}
echo env dh is: ${DH}

set MPI_PAR="wemig-1way=${DH}/other/yaxun_weo/bin/bwi-wem3d-Zh.x wewet-1way=${DH}/other/yaxun_weo/bin/bwi-wet3d.x"
echo ${MPI_PAR}

#set MIG_PAR_WAZ2D=" pdip=65 oper=foufd nvrf=3 nws=320 nxpad_beg=25 nxpad_end=25 ntpx=25" 
set MIG_PAR_WAZ3D=" pdip=65 oper=ssfpi nvrf=4 nws=144 nxpad_beg=30 nxpad_end=30 nypad_beg=25 nypad_end=25 ntpx=25 ntpy=25 memchk=n " 
echo $MIG_PAR_WAZ3D

set invPar="niter_stomp=4 niter_lin=9"
set angPar="oang=-55 nang=45 dang=2.5 ${invPar}"
echo ${angPar}

set OnewayParWAZ3D=" bUseOneway=1 "

set dump="dump1=dump1.H dump2=dump2.H"
#set P="/data/sep/zyang03/proj/RMO/Par"
set B="/data/sep/zyang03/bin"
echo 10

#clean up the tmp folder first
find /tmp/ -maxdepth 1 -type f -user zyang03 -exec rm {} \;


#set PAR_MIG=" nhx=1 dhx=25 ohx=0 nhy=1 dhy=30 ohy=0 comsou=n offset=y "
set PAR_MIG=" nhx=21 dhx=50 ohx=-500 nhy=19 dhy=60 ohy=-540 comsou=n offset=y "

