module levels_mod
use sep
integer :: nlevel(4),n(4)
integer,pointer :: ncut(:,:)
real, pointer :: rez(:,:,:,:)

contains

subroutine init_levels(nsz,nl,cut)
integer :: nl(4),nsz(4),i,j
integer,dimension(:) :: cut
allocate(ncut(4,size(cut)))

ncut=cu
nlevel=nl
n=nsz
allocate(rez(n(1),n(2),n(3),n(4)))

  do j=1,size(cut)
  do i=1,4
    ncut(i,j)=n(i)/2**min(nl(i),cut(j))
  end do
end do
  
end subroutine


subroutine init_levels_f(nsz_c,nl_c,sz_nsz,cut_c,sz_cut) BIND(C,NAME="init_levels_f03")
    use iso_c_binding
    integer(c_int),value  :: sz_nsz,sz_cut
    type(c_ptr),value     :: nsz_c,nl_c,cut_c
    integer,pointer,dimension(:)  :: nl,nsz,cut

    call c_f_pointer(nl_c,nl,   shape=[sz_nsz])
    call c_f_pointer(nsz_c,nsz, shape=[sz_nsz])
    call c_f_pointer(cut_c,cut, shape=[sz_cut])
    call init_levels(nsz,nl,cut)
end subroutine

integer function level_cut(iter,vals)
  integer :: iter
  real :: vals(:)
  integer :: icut(4)
  
  level_cut=0
  rez=reshape(vals,n)
  if(ncut(1,iter)< n(1)) rez(ncut(1,iter)+1:,:,:,:)=0
  if(ncut(2,iter)< n(2)) rez(:,ncut(2,iter)+1:,:,:)=0
  if(ncut(3,iter)< n(3)) rez(:,:,ncut(3,iter)+1:,:)=0
  if(ncut(4,iter)< n(4)) rez(:,:,:,ncut(4,iter)+1:)=0
  vals=reshape(rez,(/size(vals)/))


end function  


end module
