
module perc_mod
  use quantile_mod
  use sep
  
  implicit none
  contains


  !Interface
  subroutine perc_it_f(perc,n_c,level_c,out_c,level_out_c,szout_c,sz_szout) BIND(C,NAME="perc_it_f03") 
    use iso_c_binding
    real(c_float),value :: perc
    integer(c_int),value:: sz_szout
    type(c_ptr),value :: n_c,level_c, out_c,level_out_c,szout_c
    integer,pointer,dimension(:) :: n,level
    integer,pointer :: level_out(:)
    real,pointer,dimension(:) :: out,szout
    
    call c_f_pointer(n_c,n,shape=[4])
    call c_f_pointer(level_c,level,shape=[4])
    call c_f_pointer(out_c,out,shape=[1]) !This array is not used
    call c_f_pointer(level_out_c,level_out,shape=[product(n)])
    call c_f_pointer(szout_c,szout,shape=[sz_szout]) 
    
    call perc_it(perc,n,level,out,level_out,szout)
  end subroutine

  subroutine perc_it(perc,n,level,out,level_out,szout)
    integer  :: n(4),level(4)
    integer :: nuse(4),nold(4)
    real :: out(:)
    real,allocatable :: outv(:,:,:,:)
    real,allocatable :: tmp(:)
    integer,allocatable :: region(:,:,:,:)
    real :: perc,val,szout(:)
    integer :: nlevel,lws
    integer,allocatable :: pos_levels(:)
    integer             :: level_out(:)
    integer :: i,icheck,iold,nb(4),ib(4),ig(4),ih(4),ierr,ib1,ib2,ib3,map(100000)
    logical :: myl(4)
    real :: myv,puse
    logical :: found
    nlevel=maxval(level)
    
    nuse=n
    nold=n

  if (.true.) then
    allocate(tmp(product(n)))
  !  tmp=reshape(array,(/size(tmp)/))
   ! val=quantile(tmp,size(tmp)*perc/100.)
  !  deallocate(tmp)
    allocate(outv(n(1),n(2),n(3),n(4)),region(n(1),n(2),n(3),n(4)))
    allocate(pos_levels(product(level)))

  outv=0
  ib2=n(1)
  region=1
  lws=1

  write(0,*) "JD1",n(1),n(2),n(3),n(4)
  write(0,*) "JD2",level(1),level(2),level(3),level(4)
  do i=level(1),1,-1
    ib1=ib2/2
    outv(ib1+1:ib2,:,:,:)=outv(ib1+1:ib2,:,:,:)+(ib2-ib1)*(ib2-ib1)
    region(ib1+1:ib2,:,:,:)=region(ib1+1:ib2,:,:,:)*lws
    ib2=ib1
    lws=lws*2
    write(0,*) "CHECK ", ib1,ib2,lws
  end do

  outv(1:ib2,:,:,:)=outv(:ib2,:,:,:)+(ib2*ib2)
  region(1:ib2,:,:,:)=region(:ib2,:,:,:)*lws
    lws=1

    ib2=n(2)
  do i=level(2),1,-1
    ib1=ib2/2
    outv(:,ib1+1:ib2,:,:)=outv(:,ib1+1:ib2,:,:)+(ib2-ib1)*(ib2-ib1)
    region(:,ib1+1:ib2,:,:)=region(:,ib1+1:ib2,:,:)*lws
    ib2=ib1
        lws=lws*2
  end do
  outv(:,1:ib2,:,:)=outv(:,:ib2,:,:)+(ib2*ib2)
  region(:,1:ib2,:,:)=region(:,:ib2,:,:)*lws
    lws=1

    ib2=n(3)
  do i=level(3),1,-1
    ib1=ib2/2
    outv(:,:,ib1+1:ib2,:)=outv(:,:,ib1+1:ib2,:)+(ib2-ib1)*(ib2-ib1)
    region(:,:,ib1+1:ib2,:)=region(:,:,ib1+1:ib2,:)*lws
    ib2=ib1
        lws=lws*2

  end do
  outv(:,:,1:ib2,:)=outv(:,:,:ib2,:)+(ib2*ib2)
  region(:,:,1:ib2,:)=region(:,:,:ib2,:)*lws

    ib2=n(4)
    lws=1
  do i=level(4),1,-1
    ib1=ib2/2
    outv(:,:,:,ib1+1:ib2)=outv(:,:,:,ib1+1:ib2)+(ib2-ib1)*(ib2-ib1)
    region(:,:,:,ib1+1:ib2)=region(:,:,:,ib1+1:ib2)*lws
    ib2=ib1
    lws=lws*2
  end do
  outv(:,:,:,1:ib2)=outv(:,:,:,:ib2)+(ib2*ib2)
  region(:,:,:,1:ib2)=region(:,:,:,:ib2)*lws


  !write(0,*) "JD5",size(region),product(n),size(level_out)
  level_out=reshape(region,(/product(n)/))
  !write(0,*) "JD5.2"
  map=0
  nlevel=0
  !write(0,*) "JD5.4", maxval(level_out),minval(level_out)
  deallocate(region)
  
  !write(0,*) "JD6"
  do i=1,size(level_out)
    if(map(level_out(i))==0) then
       nlevel=nlevel+1
       map(level_out(i))=nlevel
       szout(nlevel)=level_out(i)
    end if
    level_out(i)=map(level_out(i))
  end do

  !write(0,*) "JD6.2",nlevel
  deallocate(outv)
  !write(0,*) "JD7",maxval(level_out),minval(level_out)
end if !for debug
  end subroutine
end module

