#include "stdafx.h"
#include "dmRsf.hpp"
#include "sep_params.h"
#include "cubeData.hpp"

#include "waveOpParams.h"
#include "waveOpMPI.h"

#include "param_entry.h"

#include "stackTraceC.h"
#include "commonOps.h"

#include "misc.h"
#include "dmHeaderReader.h"
#include "waveOpMPI.h"

#include "my_timer.h"

/**
 * Oneway migration using Tang's code.
 * Real 3D, migrate small data file chunks.
 */

using namespace Yang;
using namespace std;
using namespace seplib;

using boost::shared_ptr;
//Doing beam wave-equation tomography for reflection case.

#include <unistd.h>
//Do born modeling
int main (int argc, char *argv[])
{
  shared_ptr<sep_params> autoPars(new sep_params(argc,argv));
  sep_params* pars = autoPars.get();
  //initialize the temporary path
  pars->get_tmp_path();

  shared_ptr<shotFilesInfo> SshotsInfo(new shotFilesInfo());
  string fname_shotsInfo = pars->get_string("data_desc_file");
  LOG("A1.1");
  shared_ptr<hypercube> vmodshp(new hypercube());
  SshotsInfo->parsefile(fname_shotsInfo,vmodshp);
  return 0;
}

