!Wavelet transform method interface C++ <-> fortran 90

module wavelet_IF_mod
  !use wavelet3_mod
  use wavelet4_B_mod
  implicit none
  contains

  subroutine init_wavelet_transform_f(smoother_c,roughner_c,nsm,nrgh,n1,n2,n3,n4,lev1,lev2,lev3,lev4) BIND(C,NAME="init_wavelet_transform_f03")
    use iso_c_binding
    integer(c_int),value  :: n1,n2,n3,n4,lev1,lev2,lev3,lev4,nsm,nrgh
    type(c_ptr),value     :: smoother_c,roughner_c
    real,pointer,dimension(:)  :: smoother,roughner

    call c_f_pointer(smoother_c,smoother,shape=[nsm])
    call c_f_pointer(roughner_c,roughner,shape=[nrgh])
    
    !write(0,*) smoother,"sm array, rough array", roughner
    !write(0,*) "init_wav_tran_par",n1,n2,n3,n4,lev1,lev2,lev3,lev4
    call init_wavelet_transform(smoother,roughner,n1,n2,n3,n4,lev1,lev2,lev3,lev4)
  end subroutine

  subroutine set_direction_f(dir) BIND(C,NAME="set_wavelet_direction_f03")
      use iso_c_binding
      integer(c_int),value :: dir !The boolean type binding does not work
      !write(0,*) "set_direction_f",dir
      if (dir>0) then
        call set_direction(.true.)
      else
        call set_direction(.false.)
      endif
  end subroutine


    integer function wavelet_transform_op_f(adj_c,add_c,model_c,data_c) BIND(C,NAME="wavelet_transform_op_f03")
      use iso_c_binding
      !logical(C_BOOL),value :: adj,add //can not compile
      integer(c_int),value :: adj_c,add_c
      logical adj,add
      real,pointer,dimension(:) :: model,data
      
      type(c_ptr),value     :: model_c,data_c
      
      adj = .false.
      add = .false.
      if (adj_c>0) adj = .true.
      if (add_c>0) add = .true.

      !write(0,*) "wavelet_transform_op_f",adj,add

      call c_f_pointer(model_c, model,shape=[ns(1)*ns(2)*ns(3)*ns(4)])
      call c_f_pointer(data_c,  data, shape=[ns(1)*ns(2)*ns(3)*ns(4)])
      !write(0,*) "53,",ns(1),ns(2),ns(3),ns(4)
      wavelet_transform_op_f = wavelet_transform_op(adj,add,model,data)
    end function

end module

